from pypy.lang.gameboy import constants
from pypy.lang.gameboy.ram import RAM


def get_ram():
    return RAM()


def test_ram_read_write():
    ram = get_ram()
    address = 0x00
    value = 0x12
    ram.write(address, value)
    try:
        ram.read(address)
        py.test.fail()
    except Exception:
        pass
        
    assert value not in ram.work_ram
    assert value not in ram.hi_ram
    
    address = 0xC000
    ram.write(address, value)
    assert ram.read(address) == value
    assert value in  ram.work_ram
    assert value not in  ram.hi_ram
    
    address = 0xFDFF
    value += 1
    ram.write(address, value)
    assert ram.read(address) == value
    assert value in  ram.work_ram
    assert value not in  ram.hi_ram
    
    
    address = 0xFF80
    value += 1
    ram.write(address, value)
    assert ram.read(address) == value
    assert value in  ram.hi_ram
    assert value not in  ram.work_ram
    
    address = 0xFFFE
    value += 1
    ram.write(address, value)
    assert ram.read(address) == value
    assert value in  ram.hi_ram
    assert value not in  ram.work_ram
    
    address += 1
    value += 1
    ram.write(address, value)
    try:
        ram.read(address)
        py.test.fail()
    except Exception:
        pass
    assert value not in  ram.hi_ram
    assert value not in  ram.work_ram